"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
Object.defineProperty(exports, "getCssVars", {
  enumerable: true,
  get: function get() {
    return _cssVar.getCssVars;
  }
});
Object.defineProperty(exports, "getFileKey", {
  enumerable: true,
  get: function get() {
    return _cssVar.getFileKey;
  }
});
var _cssVar = require("../postcss-plugin-var-url/cssVar");
const LOADER_NAME = "css-url-loader";
const loader = function loader(content, sourceMap, additionalData) {
  const logger = this._compiler.getInfrastructureLogger(LOADER_NAME);
  // const logger = this.getLogger(LOADER_NAME);
  // logger.log("Normal input:", content); // , sourceMap, additionalData);
  const callback = this.async();
  setTimeout(() => {
    logger.log("Callback fired!");
    // this.emitFile("css-var.json", JSON.stringify(rs));
    callback(null, content, sourceMap, additionalData);
  }, 1000);
};
loader.pitch = function (remainingRequest, previousRequest, data) {
  const logger = this._compiler.getInfrastructureLogger(LOADER_NAME);
  logger.log("RM:", remainingRequest);
  logger.log("RP:", previousRequest);
  const options = this.getOptions();
  logger.log("Pitch:", options);
  data.version = "1.0.0";
};
var _default = exports.default = loader;