import { IBundleOptions, Mode } from '../interfaces';
export interface IUserConfigOptions {
    cwd: string;
    env: Mode;
}
export default function ({ cwd, env }: IUserConfigOptions): IBundleOptions;
export declare function getPreConfig(userConfig: IBundleOptions): {
    antPrefix: string;
    postcssConfig: {
        sourceMap: boolean;
        postcssOptions: {
            plugins: any[];
        };
    };
    modifyVars: {
        [x: string]: any;
    };
};
