"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;
function _path() {
  const data = _interopRequireDefault(require("path"));
  _path = function _path() {
    return data;
  };
  return data;
}
function _fs() {
  const data = require("fs");
  _fs = function _fs() {
    return data;
  };
  return data;
}
function _webpack() {
  const data = _interopRequireWildcard(require("webpack"));
  _webpack = function _webpack() {
    return data;
  };
  return data;
}
function _miniCssExtractPlugin() {
  const data = _interopRequireDefault(require("mini-css-extract-plugin"));
  _miniCssExtractPlugin = function _miniCssExtractPlugin() {
    return data;
  };
  return data;
}
function _eslintWebpackPlugin() {
  const data = _interopRequireDefault(require("eslint-webpack-plugin"));
  _eslintWebpackPlugin = function _eslintWebpackPlugin() {
    return data;
  };
  return data;
}
function _stylelintWebpackPlugin() {
  const data = _interopRequireDefault(require("stylelint-webpack-plugin"));
  _stylelintWebpackPlugin = function _stylelintWebpackPlugin() {
    return data;
  };
  return data;
}
function _cleanWebpackPlugin() {
  const data = require("clean-webpack-plugin");
  _cleanWebpackPlugin = function _cleanWebpackPlugin() {
    return data;
  };
  return data;
}
function _caseSensitivePathsWebpackPlugin() {
  const data = _interopRequireDefault(require("case-sensitive-paths-webpack-plugin"));
  _caseSensitivePathsWebpackPlugin = function _caseSensitivePathsWebpackPlugin() {
    return data;
  };
  return data;
}
function _lessPluginNpmImport() {
  const data = _interopRequireDefault(require("less-plugin-npm-import"));
  _lessPluginNpmImport = function _lessPluginNpmImport() {
    return data;
  };
  return data;
}
function _lodashWebpackPlugin() {
  const data = _interopRequireDefault(require("lodash-webpack-plugin"));
  _lodashWebpackPlugin = function _lodashWebpackPlugin() {
    return data;
  };
  return data;
}
var _UmdNoDojoAmdPlugin = _interopRequireDefault(require("./webpackPlugins/UmdNoDojoAmdPlugin"));
var _FilePathInAssetPlugin = _interopRequireDefault(require("./webpackPlugins/FilePathInAssetPlugin"));
var _IgnoreNotFoundExportPlugin = _interopRequireDefault(require("./webpackPlugins/IgnoreNotFoundExportPlugin"));
function _webpackbar() {
  const data = _interopRequireDefault(require("webpackbar"));
  _webpackbar = function _webpackbar() {
    return data;
  };
  return data;
}
var _pathConfig = _interopRequireDefault(require("./pathConfig"));
function _vueLoader() {
  const data = require("vue-loader");
  _vueLoader = function _vueLoader() {
    return data;
  };
  return data;
}
var _log = require("../log");
var _getBabelOpts = require("./getBabelOpts");
function _lodash() {
  const data = require("lodash");
  _lodash = function _lodash() {
    return data;
  };
  return data;
}
var _getUserConfig = require("./getUserConfig");
function _terserWebpackPlugin() {
  const data = _interopRequireDefault(require("terser-webpack-plugin"));
  _terserWebpackPlugin = function _terserWebpackPlugin() {
    return data;
  };
  return data;
}
function _cssMinimizerWebpackPlugin() {
  const data = _interopRequireDefault(require("css-minimizer-webpack-plugin"));
  _cssMinimizerWebpackPlugin = function _cssMinimizerWebpackPlugin() {
    return data;
  };
  return data;
}
var _cssVarWebpackPlugin = _interopRequireDefault(require("./css-var-webpack-plugin"));
function _webpack2() {
  const data = _interopRequireDefault(require("unplugin-vue-components/webpack"));
  _webpack2 = function _webpack2() {
    return data;
  };
  return data;
}
function _resolvers() {
  const data = require("unplugin-vue-components/resolvers");
  _resolvers = function _resolvers() {
    return data;
  };
  return data;
}
function _bundleStatsWebpackPlugin() {
  const data = require("bundle-stats-webpack-plugin");
  _bundleStatsWebpackPlugin = function _bundleStatsWebpackPlugin() {
    return data;
  };
  return data;
}
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _default(userConfig, cache = true) {
  function setLoaders(i) {
    const useCache = process.env.CACHE_STYLE === 'on' && cache;
    return i.filter(i => useCache ? true : i !== 'cache-loader');
  }
  const srcDir = _pathConfig.default.srcDir,
    cwd = _pathConfig.default.cwd;
  const mode = userConfig.mode,
    _userConfig$profile = userConfig.profile,
    profile = _userConfig$profile === void 0 ? false : _userConfig$profile,
    _userConfig$eslint = userConfig.eslint,
    eslint = _userConfig$eslint === void 0 ? true : _userConfig$eslint,
    _userConfig$stylelint = userConfig.stylelint,
    stylelint = _userConfig$stylelint === void 0 ? true : _userConfig$stylelint,
    absDir = userConfig.absDir,
    devtool = userConfig.devtool,
    _userConfig$output = userConfig.output,
    userConfigWebpackOutput = _userConfig$output === void 0 ? {} : _userConfig$output,
    _userConfig$externals = userConfig.externals,
    userConfigWebpackExternals = _userConfig$externals === void 0 ? {
      react: 'React',
      'react-dom': 'ReactDOM',
      'react-redux': 'ReactRedux',
      'react-router-dom': 'ReactRouterDom',
      // 'react-router-redux': 'ReactRouterRedux',
      moment: 'moment',
      antd: 'antd'
    } : _userConfig$externals,
    stats = userConfig.stats,
    logging = userConfig.logging,
    pjName = userConfig.projectName,
    routerIndex = userConfig.routerIndex,
    pkg = userConfig.pkg,
    themeMappings = userConfig.themeMappings,
    _userConfig$clean = userConfig.clean,
    clean = _userConfig$clean === void 0 ? true : _userConfig$clean,
    lodashOptions = userConfig.lodashOptions,
    _userConfig$dynamicPu = userConfig.dynamicPublicPath,
    dynamicPublicPath = _userConfig$dynamicPu === void 0 ? false : _userConfig$dynamicPu,
    dynamicCssUrlOptions = userConfig.dynamicCssUrlOptions,
    miniOptions = userConfig.miniOptions,
    vueLoaderOptions = userConfig.vueLoaderOptions,
    antdVResolverOptions = userConfig.antdVResolverOptions,
    webpackConfig = userConfig.webpack,
    alias = userConfig.alias;
  (0, _log.log)(`absDir: ${absDir}`);
  const babelPresetOpts = (0, _getBabelOpts.getBabelPresetOpts)(userConfig);
  const babelOpts = (0, _getBabelOpts.getBabelOpts)({
    cwd,
    presetOpts: babelPresetOpts
  });
  const tsBabelOpts = (0, _getBabelOpts.getTSBabelOpts)({
    cwd,
    presetOpts: babelPresetOpts
  });
  const isDev = mode === 'development';
  const withVersion = process.env.WITH_VERSION === 'true';
  const projectName = isDev && !withVersion ? pjName : pjName + '@' + pkg.version;
  const assetsRoot = '/capsule/pages/' + projectName;
  /**
   * 需要根据当前环境，生成唯一的 jsonpFunction 值，防止多个 webpack 产物装载过程中，出现 chunkId 重复
   *
   * @see https://zhuanlan.zhihu.com/p/54247567
   * @see https://www.jianshu.com/p/e22f2d539742
   * @see https://webpack.js.org/configuration/output/#outputjsonpfunction
   */
  const jsonpFunction = ('webpackJsonp' + '_' + projectName).replace(/\./g, '_');
  const old = {
    filename: '[name].js',
    chunkFilename: pathData => {
      const _pathData$chunk = pathData.chunk,
        name = _pathData$chunk.name,
        runtime = _pathData$chunk.runtime;
      const dist = name || runtime;
      if (typeof dist === 'string') {
        return dist.replace('index', '[name].[contenthash].js');
      }
      return '[name].[contenthash].js';
    }
  };
  const next = {
    filename: pathData => {
      return pathData.chunk.name === './index' ? '[name].js' : '[name].[contenthash].js';
    },
    chunkFilename: pathData => {
      return pathData.chunk.name === './index' ? '[name].js' : '[name].[contenthash].js';
    }
  };
  const isNew = /router(-\w+)?\.[tj]s$/.test((userConfig.scan || []).toString());
  const _getPreConfig = (0, _getUserConfig.getPreConfig)(userConfig),
    postcssOptions = _getPreConfig.postcssConfig,
    antPrefix = _getPreConfig.antPrefix,
    modifyVars = _getPreConfig.modifyVars;
  const lessLoaderOptions = {
    sourceMap: true,
    lessOptions: {
      javascriptEnabled: true,
      plugins: [new (_lessPluginNpmImport().default)({
        prefix: '~'
      })],
      modifyVars: _objectSpread({}, modifyVars)
    }
  };
  let cleanPatterns = ['*/'];
  if (!isNew && Array.isArray(userConfig.scan)) {
    if (userConfig.cleanPatterns === 'auto') {
      cleanPatterns = userConfig.scan.map(v => '**/' + (/\.[tj]s$/.test(v) ? _path().default.dirname(v) : v).replace(/^\.\//, '') + '/**');
    } else if (Array.isArray(userConfig.cleanPatterns)) {
      cleanPatterns = userConfig.cleanPatterns;
    }
  } else {
    cleanPatterns = ['**/*'];
  }
  const getFileLoaderAssetPath = sub => a => {
    const defaultPath = `./static/${sub}/[name]-[hash:5].[ext]`;
    if (isNew || !a) {
      return defaultPath;
    }
    const c = _path().default.dirname(a.replace(/\\/g, '/').split(/src\/pages\//)[1]);
    if (!c) {
      return defaultPath;
    }
    return `./${c}/[name]-[hash:5].[ext]`;
  };
  const plugins = [[new (_cleanWebpackPlugin().CleanWebpackPlugin)({
    cleanOnceBeforeBuildPatterns: cleanPatterns
  }), clean], [new (_webpackbar().default)({
    name: projectName,
    profile
  })], [new (_miniCssExtractPlugin().default)({
    // https://github.com/facebook/create-react-app/issues/5372
    ignoreOrder: true,
    filename: isNew ? 'style/index.css' : ({
      chunk
    }) => {
      return chunk.name.replace('index', 'style/index.css');
    },
    chunkFilename: isNew ? '[name].[contenthash].css' : ({
      chunk
    }) => {
      const name = chunk.name,
        runtime = chunk.runtime;
      const dist = name || runtime;
      if (typeof dist === 'string') {
        return dist.replace('index', 'style/[name].[contenthash].css');
      }
      return '[name].[contenthash].css';
    }
  })],
  /**
   * https://www.npmjs.com/package/case-sensitive-paths-webpack-plugin
   * 用以解决 osx 路径问题
   */
  [new (_caseSensitivePathsWebpackPlugin().default)()],
  // new webpack.ProgressPlugin((percentage, msg, addInfo) => {
  //   const stream = process.stderr;
  //   if (stream.isTTY && percentage < 0.71) {
  //     stream.cursorTo(0);
  //     stream.write(`📦  ${chalk.magenta(msg)} (${chalk.magenta(addInfo)})`);
  //     stream.clearLine(1);
  //   } else if (percentage === 1) {
  //     console.log(chalk.green('\nwebpack: bundle build is now finished.'));
  //   }
  // }),
  [new _cssVarWebpackPlugin.default(), (dynamicCssUrlOptions === null || dynamicCssUrlOptions === void 0 ? void 0 : dynamicCssUrlOptions.enabled) === true], [new (_vueLoader().VueLoaderPlugin)(), true], [new (_bundleStatsWebpackPlugin().BundleStatsWebpackPlugin)(_objectSpread({
    silent: userConfig.log !== true
  }, userConfig.bundleStats)), process.env.BUNDLE_STATS == 'true'], [(0, _webpack2().default)({
    resolvers: [(0, _resolvers().AntDesignVueResolver)(_objectSpread({
      importStyle: false
    }, antdVResolverOptions))]
  }), true], [new (_webpack().DefinePlugin)({
    __DEV__: JSON.stringify(process.env.NODE_ENV === 'development'),
    __PACK_ENV__: JSON.stringify(process.env.PACK_ENV || 'DEFAULT'),
    __PACK_META__: JSON.stringify({
      proxy: userConfig.proxy
    }),
    __ASSETS_ROOT__: JSON.stringify(assetsRoot + '/'),
    __PACKAGE_KEY__: JSON.stringify(projectName),
    'process.env.NODE_ENV': JSON.stringify(process.env.NODE_ENV),
    __ANT_PREFIX__: JSON.stringify(antPrefix),
    __VUE_OPTIONS_API__: 'false',
    __VUE_PROD_DEVTOOLS__: 'false',
    __VUE_PROD_HYDRATION_MISMATCH_DETAILS__: 'false'
  })],
  /**
   * webpack5 已将此内容移除
   */
  [new (_webpack().default.ProvidePlugin)({
    process: 'process/browser.js',
    Buffer: ['buffer', 'Buffer']
  })], [new (_lodashWebpackPlugin().default)(_objectSpread({}, typeof lodashOptions === 'boolean' ? {} : (0, _lodash().omit)(lodashOptions, ['babel']))), lodashOptions === true], [new _UmdNoDojoAmdPlugin.default(), userConfig.noDojo !== true], [new _FilePathInAssetPlugin.default({
    placeholder: '[filePlaceholder]',
    pathInCss: routerIndex ? assetsRoot : '../../../',
    pathInJs: assetsRoot,
    dynamicPublicPath: dynamicPublicPath !== false
  })], [new _IgnoreNotFoundExportPlugin.default()]].filter(([, state]) => state !== false).map(([plugin]) => plugin);
  let config = {
    mode: 'none',
    devtool,
    entry: '',
    profile: true,
    output: _objectSpread(_objectSpread({
      path: absDir,
      filename: '[name].js'
    }, isNew ? next : old), {}, {
      library: {
        type: 'umd'
      },
      environment: {
        arrowFunction: false,
        bigIntLiteral: false,
        const: false,
        destructuring: false,
        dynamicImport: false,
        forOf: false,
        module: false
      },
      umdNamedDefine: true,
      chunkLoadingGlobal: jsonpFunction,
      uniqueName: projectName
    }, userConfigWebpackOutput),
    externals: _objectSpread({}, userConfigWebpackExternals),
    resolve: {
      modules: ['node_modules', _path().default.join(cwd, 'node_modules')],
      extensions: ['.js', '.jsx', '.ts', '.tsx', '.json'],
      alias: _objectSpread({
        '@': _path().default.resolve(srcDir)
      }, alias),
      fallback: {
        fs: false,
        https: require.resolve('https-browserify'),
        http: require.resolve('http-browserify'),
        assert: require.resolve('assert/'),
        util: require.resolve('util/'),
        url: require.resolve('url'),
        path: require.resolve('path-browserify'),
        buffer: require.resolve('buffer/'),
        stream: require.resolve('stream-browserify/'),
        crypto: require.resolve('crypto-browserify')
      }
    },
    resolveLoader: {
      modules: [_path().default.resolve(process.cwd(), './node_modules'), __dirname]
    },
    module: {
      // noParse: [/moment.js/],
      rules: [
      // 针对 入口router-xx.(j|ts) 独立处理
      {
        test: /src[\\\/]router(-\w+)?\.[tj]s$/,
        exclude: /node_modules/,
        use: [{
          // 设置loader的路径
          loader: _path().default.resolve(__dirname, 'webpackLoader', 'setFunVersionLoader.js'),
          options: _objectSpread(_objectSpread({}, pkg), {}, {
            dynamicPublicPath: dynamicPublicPath !== false
          })
        }]
      },
      // ts/tsx/js/jsx
      {
        test: /\.jsx?$/,
        exclude: /node_modules/,
        use: setLoaders(['cache-loader', {
          loader: require.resolve('babel-loader'),
          options: babelOpts
        }])
      }, {
        test: /\.jsx?$/,
        include: [/pipenet-core/],
        use: setLoaders(['cache-loader', {
          loader: require.resolve('babel-loader'),
          options: babelOpts
        }])
      }, {
        test: /\.tsx?$/,
        exclude: /node_modules/,
        use: setLoaders(['cache-loader', {
          loader: require.resolve('babel-loader'),
          options: tsBabelOpts
        }])
      },
      // common css module
      {
        test: new RegExp(`^(?!.*\\.global).*\\.css`),
        exclude: [/node_modules/],
        use: setLoaders(['cache-loader', {
          loader: require.resolve('css-loader'),
          options: {
            modules: {
              localIdentName: '[name]__[local]___[hash:base64:5]'
            },
            url: _url => !/^\//.test(_url)
          }
        }, {
          loader: require.resolve('postcss-loader'),
          options: postcssOptions
        }])
      },
      // common css
      {
        test: new RegExp(`^(.*\\.global).*\\.css`),
        exclude: [/node_modules/],
        use: setLoaders([_miniCssExtractPlugin().default.loader, 'cache-loader', {
          loader: require.resolve('css-loader'),
          options: {
            url: _url2 => !/^\//.test(_url2)
          }
        }, {
          loader: require.resolve('postcss-loader'),
          options: postcssOptions
        }])
      },
      // antd css
      {
        test: /\.css$/,
        include: [/node_modules|antd\.css/],
        use: setLoaders([_miniCssExtractPlugin().default.loader, 'cache-loader', {
          loader: require.resolve('css-loader'),
          options: {
            url: false
          }
        }, {
          loader: require.resolve('postcss-loader'),
          options: postcssOptions
        }])
      },
      // common less module
      {
        // test: new RegExp('^(?!.*\\.global).*\\.less'),
        test: /(?<!\.theme|\.global)\.less/,
        exclude: [/node_modules/],
        use: setLoaders([{
          loader: _miniCssExtractPlugin().default.loader,
          options: {
            publicPath: './'
          }
        }, 'cache-loader', {
          loader: require.resolve('css-loader'),
          options: {
            sourceMap: true,
            modules: {
              localIdentName: '[name]__[local]___[hash:base64:5]'
            },
            url: _url3 => !/^\//.test(_url3)
          }
        }, {
          loader: require.resolve('postcss-loader'),
          options: postcssOptions
        }, {
          loader: require.resolve('less-loader'),
          options: lessLoaderOptions
        }])
      },
      // common less
      {
        test: new RegExp('^(.*\\.global).*\\.less'),
        exclude: [/node_modules/],
        use: setLoaders([{
          loader: _miniCssExtractPlugin().default.loader,
          options: {
            publicPath: './'
          }
        }, 'cache-loader', {
          loader: require.resolve('css-loader'),
          options: {
            url: _url4 => !/^\//.test(_url4)
          }
        }, {
          loader: require.resolve('postcss-loader'),
          options: postcssOptions
        }, {
          loader: require.resolve('less-loader'),
          options: lessLoaderOptions
        }])
      },
      // antd less
      {
        test: /\.less$/,
        include: [/node_modules|antd\.less/],
        use: setLoaders([{
          loader: _miniCssExtractPlugin().default.loader,
          options: {
            publicPath: './'
          }
        }, 'cache-loader', {
          loader: require.resolve('css-loader'),
          options: {
            sourceMap: true,
            modules: false,
            url: _url5 => !/^\//.test(_url5)
          }
        }, {
          loader: require.resolve('postcss-loader'),
          options: postcssOptions
        }, {
          loader: require.resolve('less-loader'),
          options: lessLoaderOptions
        }])
      }, {
        test: /\.theme\.less$/,
        use: ['file-loader', {
          loader: require.resolve('./x-theme-loader'),
          options: {
            plugins: postcssOptions.postcssOptions.plugins,
            imports: false,
            basePath: './src',
            mappings: _objectSpread({
              '~antd/dist/antd.less': ''
            }, themeMappings)
          }
        }],
        exclude: ['/node_modules/']
      },
      // icon.svg
      {
        test: new RegExp('^(.*\\.icon).*\\.svg'),
        use: [{
          loader: require.resolve('svg-sprite-loader')
        }]
      },
      // svg
      {
        test: new RegExp('^(?!.*\\.icon).*\\.svg'),
        use: [{
          loader: require.resolve('url-loader'),
          options: {
            limit: '10240',
            name: getFileLoaderAssetPath('images')
            // publicPath: '[filePlaceholder]',
          }
        }]
      },
      // image
      {
        test: /\.(png|jpe?g|gif|cur)$/,
        use: [{
          loader: require.resolve('url-loader'),
          options: {
            limit: '10240',
            name: getFileLoaderAssetPath('images')
            // publicPath: '[filePlaceholder]',
          }
        }]
      }, {
        test: /\.(eot|ttf|woff2?)$/,
        use: [{
          loader: require.resolve('file-loader'),
          options: {
            limit: 10240,
            name: getFileLoaderAssetPath('fonts')
            // publicPath: '[filePlaceholder]',
          }
        }]
      }, {
        test: /\.vue?$/,
        use: [{
          loader: require.resolve('vue-loader'),
          options: _objectSpread({}, vueLoaderOptions)
        }]
      }]
    },
    plugins,
    infrastructureLogging: logging || {
      level: 'error'
    },
    stats: _objectSpread({
      all: false,
      version: false,
      timings: true,
      modules: false,
      modulesSpace: 0,
      assets: false,
      assetsSpace: 0,
      errors: true,
      errorsCount: true,
      warnings: true,
      warningsCount: true,
      logging: 'warn'
    }, stats)
  };
  if (userConfig.transCompile) {
    config.module.rules.push({
      test: /\.m?j|tsx?$/,
      include: userConfig.transCompile || [],
      use: setLoaders(['cache-loader', {
        loader: require.resolve('babel-loader'),
        options: babelOpts
      }])
    });
  }
  if (!isDev) {
    config.optimization = _objectSpread({
      minimize: true,
      minimizer: [new (_terserWebpackPlugin().default)({
        terserOptions: miniOptions === null || miniOptions === void 0 ? void 0 : miniOptions.terser
      }), (miniOptions === null || miniOptions === void 0 ? void 0 : miniOptions.compressCss) !== false && new (_cssMinimizerWebpackPlugin().default)({
        minify: _cssMinimizerWebpackPlugin().default.lightningCssMinify,
        minimizerOptions: miniOptions === null || miniOptions === void 0 ? void 0 : miniOptions.css
      })].filter(Boolean)
    }, userConfig.optimization);
  }
  // eslint
  if (eslint) {
    const plugin = new (_eslintWebpackPlugin().default)({
      exclude: ['/node_modules'],
      extensions: ['js', 'ts', 'tsx', 'jsx'],
      formatter: require.resolve('eslint-friendly-formatter'),
      fix: false,
      context: _path().default.resolve(srcDir)
    });
    config.plugins.push(plugin);
  }
  // stylelint
  if (stylelint) {
    const stylePlugin = new (_stylelintWebpackPlugin().default)({
      exclude: ['/node_modules'],
      extensions: ['css', 'less'],
      fix: false,
      context: _path().default.resolve(srcDir)
    });
    config.plugins.push(stylePlugin);
  }
  // 判断是否有第三方配置
  config.plugins.push(...(userConfig.webpackPlugins || []));
  if (typeof webpackConfig === 'function') {
    config = webpackConfig(config) || config;
  }
  const userWebpackConfigPath = _path().default.join(cwd, 'webpack.config.js');
  if ((0, _fs().existsSync)(userWebpackConfigPath)) {
    // eslint-disable-next-line @typescript-eslint/no-require-imports
    const userWebpackConfig = require(userWebpackConfigPath);
    config = userWebpackConfig(config);
  }
  return config;
}