declare class Writer {
    private __lines;
    /**
     * Creates a new Writer with the given lines.
     *
     * @param lines The lines to set for the Writer.
     */
    constructor(lines: Array<string>);
    /**
     * Writes the lines for this writer into the output array.
     *
     * @param output The output lines to which the Writer's lines should be appended.
     * @param previousLine The previous line that was added to output.
     */
    write(output: Array<string>, previousLine: string): string;
}
export default Writer;
