"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = runtimeRootPathLoader;
function _loaderUtils() {
  const data = _interopRequireDefault(require("loader-utils"));
  _loaderUtils = function _loaderUtils() {
    return data;
  };
  return data;
}
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function runtimeRootPathLoader(source) {
  const options = _loaderUtils().default.getOptions(this);
  console.log(options);
  const uniqueId = `${options.projectName}-${Date.now().toString(36)}`;
  return `
    __webpack_public_path__ = window['${uniqueId}'];
    export function __getPageUniqueId() {
      return '${uniqueId}'
    }
    ${source}
  `;
}