import { Model } from './interface';
import { Dictionary } from '../interfaces';
interface IRouterItemConfig {
    component?: () => Promise<{
        default: any;
    }>;
    models?: (() => Promise<{
        default: Model;
    }>)[];
    func?: () => Promise<{
        default: () => void;
    }>;
}
export type IRouterConfig = Dictionary<IRouterItemConfig>;
export default function defineRouterConfig(config: IRouterConfig): IRouterConfig;
export {};
