"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.error = error;
exports.log = log;
exports.setLogLevel = setLogLevel;
exports.warn = warn;
function _chalk() {
  const data = _interopRequireDefault(require("chalk"));
  _chalk = function _chalk() {
    return data;
  };
  return data;
}
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
let printLog = false;
function log(msg) {
  if (printLog) {
    return;
  }
  console.log(msg);
}
function error(msg) {
  console.log(_chalk().default.red(msg));
}
function warn(msg) {
  console.log(_chalk().default.yellow(msg));
}
function setLogLevel(logLevel) {
  printLog = logLevel !== true;
}