"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.compile = compile;
Object.defineProperty(exports, "copyPublic", {
  enumerable: true,
  get: function get() {
    return _compile.copyPublic;
  }
});
var _log = require("./log");
var _compile = require("./utils/compile");
function compile(options, done) {
  // const targetDir = path.join(distDir, projectName);
  // rimraf.sync(targetDir);
  // 一般场景都不要开启，因为默认会使用 webpack 处理 less 以及其他静态资源
  if (options.useLess) {
    if (options.entryStyle) {
      (0, _log.log)('start less');
      (0, _compile.compileLess2)(options, () => {
        (0, _log.log)('start dist');
        (0, _compile.dist)(options, done);
      });
    } else {
      (0, _log.log)('start css');
      (0, _compile.compileLess)(options);
      (0, _log.log)('start dist');
      (0, _compile.dist)(options, done);
    }
  } else {
    (0, _log.log)('only dist');
    (0, _compile.dist)(options, done);
  }
}