"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _log = require("../../log");
class BabelRegister {
  register() {
    (0, _log.log)('register');
    require('@babel/register')({
      presets: [require.resolve('../../babel-preset-ppt/node')],
      ignore: [/node_modules/],
      extensions: ['.jsx', '.js', '.ts', '.tsx'],
      babelrc: false,
      cache: false
    });
  }
}
exports.default = BabelRegister;