import lodash from 'lodash';
import deepmerge from 'deepmerge';
import createDebug, { Debugger } from 'debug';
import isLernaPackage from './isLernaPackage/isLernaPackage';
import mergeConfig from './mergeConfig/mergeConfig';
import * as printLog from './printLog';
export { isLernaPackage };
export { lodash };
export { deepmerge };
export { default as compatESModuleRequire } from './compatESModuleRequire/compatESModuleRequire';
export { default as winPath } from './winPath/winPath';
export { createDebug, Debugger };
export { mergeConfig };
export { printLog };
export declare function filterEmptyKey<T extends Record<string, any>>(o: T, excludeKeys?: (keyof T)[]): T;
