type Exclude = (string | RegExp | ((v: string) => boolean))[];
export interface CreateZipOptions {
    exportFile: string;
    basePath: string;
    fileList: string[];
    outputDir?: string;
    excludeDirs?: Exclude;
    excludes?: Exclude;
}
export declare function createZip(options: CreateZipOptions, callback: (size: number) => void): Promise<void>;
export declare const compileExp: (str: string, dataSet: Record<string, string | number>) => string;
interface PackOptions {
    file?: string;
    excludeDirs?: Exclude;
    excludes?: Exclude;
    outDir?: string;
}
export declare function pack(packOptions: PackOptions): void;
declare const _default: () => void;
export default _default;
