import { IBabelTargets, IImportPluginOpts } from '../../interfaces';
export interface IOpts {
    typescript?: boolean;
    react?: object;
    env?: object;
    transformRuntime?: object;
    reactRemovePropTypes?: boolean;
    import?: IImportPluginOpts[];
    lodash?: boolean | {
        id: string | string[];
        cwd: string;
    };
}
export interface IBuildInOpts {
    typescript: boolean;
    env: {
        loose: boolean;
        useBuiltIns: string;
        corejs: number;
        modules: boolean;
        targets: IBabelTargets;
    };
    react: {
        development: boolean;
    };
    transformRuntime: Record<string, any>;
    reactRemovePropTypes: boolean;
}
