"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var globals = _interopRequireWildcard(require("./globals"));
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function removeEmptyStringsFromEnd(output) {
  while (!output[output.length - 1]) {
    output.pop();
  }
}
/**
 * Iterates through writers and invokes their write
 * function, building the output array.
 */
function generateOutput() {
  var output = globals.output;
  var writers = globals.writers;
  var previousLine = '';
  writers.forEach(writer => {
    previousLine = writer.write(output, previousLine);
  });
  removeEmptyStringsFromEnd(output);
}
var _default = exports.default = generateOutput;