"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = loadDotEnv;
function _fs() {
  const data = require("fs");
  _fs = function _fs() {
    return data;
  };
  return data;
}
function _dotenv() {
  const data = require("dotenv");
  _dotenv = function _dotenv() {
    return data;
  };
  return data;
}
/**
 * dotenv wrapper
 * @param envPath string
 */
function loadDotEnv(envFilePath) {
  if ((0, _fs().existsSync)(envFilePath)) {
    const parsed = (0, _dotenv().parse)((0, _fs().readFileSync)(envFilePath, 'utf-8')) || {};
    Object.keys(parsed).forEach(key => {
      if (!process.env.hasOwnProperty(key)) {
        process.env[key] = parsed[key];
      }
    });
  }
}