"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = transformLessToLess;
function _postcss() {
  const data = _interopRequireDefault(require("postcss"));
  _postcss = function _postcss() {
    return data;
  };
  return data;
}
function _postcssLess() {
  const data = _interopRequireDefault(require("postcss-less"));
  _postcssLess = function _postcssLess() {
    return data;
  };
  return data;
}
var _lessBundlePromise = _interopRequireDefault(require("./less-bundle-promise"));
var _log = require("../log");
var _getUserConfig = require("./getUserConfig");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function transformLessToLess(_x, _x2) {
  return _transformLessToLess.apply(this, arguments);
}
function _transformLessToLess() {
  _transformLessToLess = _asyncToGenerator(function* (mainLessFile, config) {
    try {
      const colorless = yield (0, _lessBundlePromise.default)({
        src: mainLessFile
      });
      const _getPreConfig = (0, _getUserConfig.getPreConfig)(_objectSpread(_objectSpread({}, config), {}, {
          less2CssVarConfig: {
            enabled: false
          }
        })),
        postcssConfig = _getPreConfig.postcssConfig;
      const _yield$postcss$proces = yield (0, _postcss().default)(postcssConfig.postcssOptions.plugins).process(colorless, {
          syntax: _postcssLess().default,
          from: mainLessFile
        }),
        css = _yield$postcss$proces.css;
      return css;
    } catch (err) {
      (0, _log.error)(err);
    }
  });
  return _transformLessToLess.apply(this, arguments);
}