import { IPptTestArgs } from '../types';
export default function (cwd: string, args: IPptTestArgs): {
    maxWorkers?: number;
    collectCoverageFrom: string[];
    moduleFileExtensions: string[];
    moduleNameMapper: {
        '\\.(css|less|sass|scss|stylus)$': string;
    };
    setupFiles: string[];
    setupFilesAfterEnv: string[];
    testEnvironment: string;
    testMatch: string[];
    testPathIgnorePatterns: string[];
    transform: {
        '^.+\\.(js|jsx)$': string;
        '^.+\\.(ts|tsx)$': string;
        '^.+\\.(css|less|sass|scss|stylus)$': string;
        '^(?!.*\\.(js|jsx|ts|tsx|css|less|sass|scss|stylus|json)$)': string;
    };
    verbose: boolean;
    transformIgnorePatterns: any[];
};
