'use strict';

function _react() {
  const data = _interopRequireDefault(require('react'));
  _react = function _react() {
    return data;
  };
  return data;
}
function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : {
    default: obj
  };
}
const babelJest = require('babel-jest');
module.exports = babelJest.createTransformer({
  presets: [[require.resolve('@babel/preset-env'), {
    loose: true,
    targets: {
      browsers: ['last 2 versions', 'Firefox ESR', '> 1%', 'ie >= 9', 'iOS >= 8', 'Android >= 4']
    }
  }], [require.resolve('@babel/preset-typescript'), {
    allowDeclareFields: false
  }], require.resolve('@babel/preset-react')],
  plugins: [[require.resolve('@babel/plugin-transform-typescript'), {
    allowDeclareFields: true
  }], [require.resolve('@babel/plugin-proposal-decorators'), {
    legacy: true
  }], [require.resolve('@babel/plugin-proposal-class-properties'), {
    loose: true
  }], [require.resolve('@babel/plugin-syntax-dynamic-import')], [require.resolve('@babel/plugin-transform-regenerator')]],
  babelrc: false,
  configFile: false
});