import { runCLI } from 'jest';
import { options as CliOptions } from 'jest-cli/build/cli/args';
export type ArgsType<T extends (...args: any[]) => any> = T extends (...args: infer U) => any ? U : never;
export interface IPptTestArgs extends Partial<ArgsType<typeof runCLI>['0']> {
    version?: boolean;
    cwd?: string;
    debug?: boolean;
    e2e?: boolean;
    package?: string;
}
export type PickedJestCliOptions = {
    [T in keyof typeof CliOptions]?: T extends keyof IPptTestArgs[T] ? T : typeof CliOptions[T] extends {
        alias: infer U;
    } ? IPptTestArgs[T] : never;
};
