"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.mkdirsSync = mkdirsSync;
exports.writeFileSync = writeFileSync;
function _fs() {
  const data = require("fs");
  _fs = function _fs() {
    return data;
  };
  return data;
}
function _path() {
  const data = require("path");
  _path = function _path() {
    return data;
  };
  return data;
}
/**
 * 递归创建目录 同步方法
 * @param dirname
 * @returns {boolean}
 */
function mkdirsSync(dirname) {
  if ((0, _fs().existsSync)(dirname)) {
    return true;
  } else {
    if (mkdirsSync((0, _path().dirname)(dirname))) {
      (0, _fs().mkdirSync)(dirname);
      return true;
    }
  }
  return false;
}
/**
 * 同步写入到文件
 * @param dir
 * @param name
 * @param content
 */
function writeFileSync(dir, name, content) {
  if (!(0, _fs().existsSync)(dir)) {
    mkdirsSync(dir);
  }
  (0, _fs().writeFileSync)((0, _path().join)(dir, name), content);
}