"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "compatESModuleRequire", {
  enumerable: true,
  get: function get() {
    return _compatESModuleRequire.default;
  }
});
Object.defineProperty(exports, "createDebug", {
  enumerable: true,
  get: function get() {
    return _debug().default;
  }
});
Object.defineProperty(exports, "deepmerge", {
  enumerable: true,
  get: function get() {
    return _deepmerge().default;
  }
});
exports.filterEmptyKey = filterEmptyKey;
Object.defineProperty(exports, "isLernaPackage", {
  enumerable: true,
  get: function get() {
    return _isLernaPackage.default;
  }
});
Object.defineProperty(exports, "lodash", {
  enumerable: true,
  get: function get() {
    return _lodash().default;
  }
});
Object.defineProperty(exports, "mergeConfig", {
  enumerable: true,
  get: function get() {
    return _mergeConfig.default;
  }
});
exports.printLog = void 0;
Object.defineProperty(exports, "winPath", {
  enumerable: true,
  get: function get() {
    return _winPath.default;
  }
});
function _lodash() {
  const data = _interopRequireDefault(require("lodash"));
  _lodash = function _lodash() {
    return data;
  };
  return data;
}
function _deepmerge() {
  const data = _interopRequireDefault(require("deepmerge"));
  _deepmerge = function _deepmerge() {
    return data;
  };
  return data;
}
function _debug() {
  const data = _interopRequireDefault(require("debug"));
  _debug = function _debug() {
    return data;
  };
  return data;
}
var _isLernaPackage = _interopRequireDefault(require("./isLernaPackage/isLernaPackage"));
var _mergeConfig = _interopRequireDefault(require("./mergeConfig/mergeConfig"));
var printLog = _interopRequireWildcard(require("./printLog"));
exports.printLog = printLog;
var _compatESModuleRequire = _interopRequireDefault(require("./compatESModuleRequire/compatESModuleRequire"));
var _winPath = _interopRequireDefault(require("./winPath/winPath"));
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function filterEmptyKey(o, excludeKeys = []) {
  Object.keys(o).forEach(i => {
    if (typeof o[i] === 'undefined' || o[i] === '' || excludeKeys.includes(i)) {
      delete o[i];
    }
  });
  return o;
}